:: Duke Map Loader for Duke Nukem 3d
:: Report errors at duke3d.bigsleep.net
:: Written by Richard Gates
:: Sunday, September 07, 2003, version 1.0
:: To use this program type
:: duke-map mapname
:: where duke-map is this file and 
:: mapname is the folder that contains the map files you want to play
:: Second through fifth parameters are passed on to duke3d
:: so that you can use switches like /M (no monsters)
::
:: Options
:: /?, /h - for Help
:: mapname run - copies files only for running another program (like iC)
:: mapname restore - restores last file backup/ copy
::
@echo off
:restart
if "%1"=="" goto noinput
:: This program tries use Choice.com
for %%p in (%PATH%) do if exist %%p\CHOICE.COM set ZUC=Y
if "%1"=="/?" goto instructions
if "%1"=="/h" goto instructions
if "%1"=="/H" goto instructions
:: If you edit this file, Make sure Word Wrap is OFF!
:: To append to the log file comment out this next line
if not "%2"=="restore" echo This is a log file for duke-map.bat > .\duke-map.log
echo This keeps a record of map files moved >> .\duke-map.log
echo. >> .\duke-map.log
echo.
goto envtest
:envok
:: If you want to add other functions to this file
:: You could probably CALL a batch file here, e.g. if you need to load a driver

cls
if not exist %1\nul goto badinput
:: This program uses Find.exe
for %%p in (%PATH%) do if exist %%p\FIND.EXE set ZUF=Y
if "%ZUF%"=="Y" goto usefindset
:: Deal with the fact we can't use Find.exe
echo FIND.EXE not found in %PATH% >> .\duke-map.log
echo. >> .\duke-map.log
echo FIND.EXE not found in your PATH
echo Your current PATH is
echo.
echo %PATH%
echo.
echo This program works better if the
echo DOS program FIND.EXE is in your PATH
echo.
echo Press CTRL+C to abort now
echo or
pause
echo.
set ZUF=N
:usefindset
if "%ZUF%"=="N" goto setusechoice
echo. | date | find.exe /v "): " >> .\duke-map.log
echo. | time | find.exe /v ": " >> .\duke-map.log

:setusechoice
:: This program uses Choice.com
if "%ZUC%"=="Y" goto usechoiceset
:: Deal with the fact we can't use Choice.com
echo CHOICE.COM not found in %PATH% >> .\duke-map.log
echo. >> .\duke-map.log
echo CHOICE.COM not found in your PATH
echo Your current PATH is
echo.
echo %PATH%
echo.
echo This program works better if the
echo DOS program CHOICE.COM is in your PATH
echo.
echo Press CTRL+C to abort now
echo or
pause
echo.
set ZUC=N
:usechoiceset

:: Get the current directory into a variable
set CWD=-current directory-
if "%ZUF%"=="N" goto cwdset
cd > .\dmtmp1zz.tmp
echo. >> .\dmtmp1zz.tmp
echo REM This is a tempory file - you may delete it > dmtmp1zz.bat
date < .\dmtmp1zz.tmp | find.exe "):" >> .\dmtmp1zz.bat
echo REM This is a tempory file - you may delete it > Enter.bat
echo set CWD=%%4>> .\Enter.bat
for %%z in (call del) do %%z .\dmtmp1zz.bat
del .\Enter.bat
del .\dmtmp1zz.tmp
:cwdset
set CWD=%CWD%\

:: Skip to restore routine
if "%2"=="restore" goto askrestore
if "%2"=="RESTORE" goto askrestore

:: Duke3d.exe must be in the current directory
if not exist .\DUKE3D.EXE goto noduke
:checkver
:: Check for v1.3d and set DUKEVERSION
if "%ZUF%"=="N" goto makever
echo.
duke3d.exe /j | find.exe /i "v1.3D" > nul
if errorlevel 0 set ZDV=v1.3D
if errorlevel 1 set ZDV=Atomic
echo.
echo Detected Duke Nukem %ZDV% >> .\duke-map.log
echo Detected Duke Nukem %ZDV%
:logo
echo 
echo. 
echo 
echo  Duke Nukem 3D Map Loader 
echo    written by Bigsleep    
echo    duke3d.bigsleep.net    
echo 
echo.
echo.
echo Current directory is %CWD% >> .\duke-map.log
echo. >> .\duke-map.log
echo Reading files in %CWD%%1\
dir /b/a-d/p %1
echo Reading files in %CWD%%1\ >> .\duke-map.log
cd %1
for %%x in (*.*) do echo %%x >> ..\duke-map.log
cd ..
echo. >> .\duke-map.log
echo.
echo These file names will be stored in %CWD%duke-map.log
echo.
echo Ready to copy
pause

:: Check for Duke files that need to be renamed
for %%f in (*.*) do if exist %1\%%f goto backup
goto copyfiles
:backup
cls
echo Files need to be backed up
echo Files need to be backed up >> .\duke-map.log
echo. >> .\duke-map.log
if not exist %1\backup.tmp\nul goto backup3
if not exist %1\backup.tmp\* goto backup2
echo.
echo !WARNING! back up files exist in 
echo %CWD%%1\backup.tmp
echo They will be deleted if you continue.
echo.
echo If you experienced a crash and need to restore these files,
if "%ZUC%"=="N" goto backup1
echo   Press R or Y
echo   To attempt to Restore these files and quit
echo Or
echo   Press D or N
echo   To Delete these files and continue
echo Or
echo   Press X or Q
echo   To Quit this program or read Help
echo.
choice.com /n/c:dnryxqh/T:r,30 (R)estore, (D)elete, or e(X)it -
if errorlevel 5 goto reset
if errorlevel 3 goto restore
goto backup1a
:backup1
echo     %0 %1 restore
echo   and the restore option will replace these files
echo Press CTRL-C to quit now.
echo or
pause
:backup1a
echo.
del %1\backup.tmp\*?.* >> .\duke-map.log
if not exist %1\backup.tmp\* echo Deleted all files in %1\backup.tmp\
if not exist %1\backup.tmp\* echo Deleted all files in %1\backup.tmp\ >> .\duke-map.log
:backup2
rd %1\backup.tmp >> .\duke-map.log
if not exist %1\backup.tmp\nul echo Deleted directory %1\backup.tmp
if not exist %1\backup.tmp\nul echo Deleted directory %1\backup.tmp >> .\duke-map.log
:backup3
md %1\backup.tmp >> .\duke-map.log
if exist %1\backup.tmp\nul echo Created directory %1\backup.tmp
if exist %1\backup.tmp\nul echo Created directory %1\backup.tmp >> .\duke-map.log
echo.
echo. >> .\duke-map.log
echo Backing up files to %1\backup.tmp\
echo.
echo Backing up files >> .\duke-map.log
for %%f in (*.*) do if exist %1\%%f copy .\%%f %1\backup.tmp
cd %1\backup.tmp
for %%f in (*.*) do echo %%f >> ...\duke-map.log
cd ...
echo To %1\backup.tmp\ >> .\duke-map.log
echo. >> .\duke-map.log
:copyfiles
:: Copy map files to Duke3D folder
echo Copying %1 map files to %CWD%
echo.
echo Copying %1 map files >> .\duke-map.log
copy %1\*.* >> .\duke-map.log
echo To %CWD% >> .\duke-map.log
echo. >> .\duke-map.log
echo.
if "%2"=="run" goto runex
if not "%2"=="RUN" goto startgame
:runex
echo Option "run" selected >> .\duke-map.log
echo You selected the "run" option
echo To restore your files enter the command -
echo %0 %1 restore
echo.
echo Press any key to run your other program
pause >nul
set ZDV=
set ZUF=
set ZUC=
set CWD=
set CMDLINE=
echo Operation Complete
echo Operation Complete >> .\duke-map.log
echo. >> .\duke-map.log
goto end

:startgame
:: Start Duke Nukem
if exist %1\*.map goto loadmap
set ZDV=
set ZMP=
set ZMN=
echo No maps in %1 folder >> .\duke-map.log
goto loadmap5
:loadmap
set ZMP=-map
if "%ZUF%"=="N" goto loadmap1
if "%ZUC%"=="N" goto loadmap1
dir /a-d/w/-p %1\*.map | find.exe " 1 file(s) " >nul
if errorlevel 1 goto loadmap3
:loadmap1
if not exist %1\%1.map goto loadmap2
set ZDV=
set ZMN=%1
goto loadmap4
:loadmap2
for %%m in (*.MAP) do if exist %1\%%m set ZMN=%%m
goto loadmap4
:loadmap3
:: Choose map
set CMDLINE=
cls
echo.
echo Pick which map you want to play -
cd %1
if exist %1.map set ZMN=%1.MAP
if "%ZMN%"=="" for %%m in (*.MAP) do set ZMN=%%m
for %%m in (*.MAP) do if not "%ZMN%"=="%%m" set ZM2=%%m
for %%m in (*.MAP) do if not "%ZMN%"=="%%m" if not "%ZM2%"=="%%m" set ZM3=%%m
cd ..
echo.
echo (1) Default (%ZMN%)
echo (2) %ZM2%
if not "%ZM3%"=="" echo (3) %ZM3%
echo.
choice.com /n/c:123ex/T:1,20 Map Number, or e(X)it -
if errorlevel 4 goto restore
if errorlevel 2 if not "%ZM2%"=="" set ZMN=%ZM2%
if errorlevel 3 if not "%ZM3%"=="" set ZMN=%ZM3%
:loadmap4
echo Using map - %ZMN% >> .\duke-map.log
:loadmap5
if not "%2"=="" echo Using options %2 %3 %4 %5 %6 >> .\duke-map.log
echo Starting Duke Nukem 3D >> .\duke-map.log
echo Starting Duke Nukem 3D
echo. >> .\duke-map.log
set ZM2=
set ZM3=
set ZDV=
.\Duke3d %ZMP% %ZMN% %2 %3 %4 %5 %6
:: To see any error codes from Duke3D uncomment the next line
::pause
set ZMN=
set ZMP=
:restore
cls
if "%ZUF%"=="N" goto restore1
echo. | date | find.exe /v "): " >> .\duke-map.log
echo. | time | find.exe /v ": " >> .\duke-map.log
:restore1
echo Current directory is %CWD% >> .\duke-map.log
echo. >> .\duke-map.log
if "%1"=="" goto p1error
if not exist %1\nul goto p1error
if not exist %1\duke3d.cfg goto restore2
echo Saving Duke3D.cfg
echo Copy duke3d.cfg to %1 >> .\duke-map.log
copy .\duke3d.cfg %1 >> .\duke-map.log
:restore2
echo Deleting %1 map file copies in %CWD%
echo.
echo Deleting %1 map file copies >> .\duke-map.log
cd %1
for %%f in (*.*) do echo %%f >> ..\duke-map.log
for %%f in (*.*) do del ..\%%f >> ..\duke-map.log
cd ..
echo In %CWD% >> .\duke-map.log
echo. >> .\duke-map.log
if not exist %1\backup.tmp\nul goto restore3
echo Restoring backed-up files to %CWD%
echo.
echo Restoring backed-up files >> .\duke-map.log
copy %1\backup.tmp\*.* >> .\duke-map.log
echo To %CWD% >> .\duke-map.log
echo. >> .\duke-map.log
del %1\backup.tmp\*?.* >> .\duke-map.log
rd %1\backup.tmp >> .\duke-map.log
if not exist %1\backup.tmp\nul echo Files restored to %CWD%
if not exist %1\backup.tmp\nul echo Files restored to %CWD% >> .\duke-map.log
:restore3
echo Operation Complete
echo Operation Complete >> .\duke-map.log
echo. >> .\duke-map.log
set ZUF=
set CWD=
set CMDLINE=
goto end

:askrestore
cls
echo !WARNING!
echo.
echo I'm about to delete these files in %CWD%
echo.
dir /a-d/b/p %1
echo.
echo Continue only if you are sure that %1 is the last map you played.
echo If you are unsure,
echo Press CTRL+C to exit now and check Duke-Map.log
echo or
pause
echo.
goto restore

:makever
:: If we can't use find we do it this way
cls
duke3d /j
:: If VER15.TXT exists, assume it's Atomic
if exist DUKE13D.VER goto foundduke13d
if exist ATOMIC.VER goto foundatomic
if exist VER15.TXT goto foundver15
:pickversion
:: Else pick Duke Nukem version
if "%ZUC%"=="N" goto verhelp
echo.
echo Choose your Duke Nukem version:
choice.com /n/c:13d2a45px 1.3D(1), Atomic(2), or e(X)it
if errorlevel 9 goto reset
if errorlevel 4 goto makeatomic
if errorlevel 1 goto makeduke13d
:makeduke13d
duke3d /j > .\DUKE13D.VER
echo.
echo I created the file DUKE13D.VER  
echo If you made the wrong choice, or
echo if you upgrade to Atomic, delete DUKE13D.VER
echo    press CTRL+C to quit
pause
echo.
:set13d
set ZDV=v1.3D
goto logo
:makeatomic
duke3d /j > ATOMIC.VER
echo.
echo I created the file ATOMIC.VER  
echo If you made the wrong choice, delete ATOMIC.VER
echo.
echo    press CTRL+C to quit
pause
echo.
:setatomic
set ZDV=Atomic
goto logo
:foundduke13d
:: Make sure we didn't upgrade
echo.
echo Duke Nukem 3D version 1.3D (found DUKE13D.VER)
echo Does this match the version printed at the top of the screen?
if "%ZUC%"=="Y" goto founddu1
echo.
echo If the versions above match, hit space to continue.
echo.
echo If they DO NOT match, press CTRL+C and then delete DUKE13D.VER
echo.
pause
echo.
goto set13d
:founddu1
echo.
echo Press Y if the versions above match.
echo.
echo Press N if they DO NOT match. You have 5 seconds.
echo.
choice.com /n/c:nyx/T:y,5 Match(Y), Do Not Match(N), or e(X)it
if errorlevel 3 goto reset
if errorlevel 2 goto set13d
del .\DUKE13D.VER
goto pickversion
:foundver15
echo.
echo Duke Nukem 3D Atomic 1.5 version (found VER15.TXT)
echo.
pause
echo.
goto setatomic
:foundatomic
echo.
echo Duke Nukem 3D Atomic version (found ATOMIC.VER)
echo.
goto setatomic
:verhelp
echo.
echo I am unable to detect your Duke Nukem version
echo If you have version 1.3D make a file named
echo   DUKE13D.VER
echo.
echo If you have the Atomic version make a file named
echo   ATOMIC.VER
echo.
echo If you upgraded from the Plutonium Pak to 1.5
echo   you should have a file named VER15.TXT
echo   if not you can just make that file
echo Version 1.3D uses different options than 1.4 and 1.5 Atomic
echo.
echo Press any key to quit, and make the correct file...
pause >nul
goto reset

:p1error
echo !ERROR! Unable to delete map files,
echo check %CWD%duke-map.log
echo !ERROR! Unable to delete map files >> .\duke-map.log
echo. >> .\duke-map.log
goto reset

:noduke
:: We didn't find Duke3d.exe
echo oops!
if "%ZUF%"=="N" goto noduke1
echo I couldn't find DUKE3D.EXE in %CWD%
:noduke1
echo I can't do anything without the file DUKE3D.EXE
echo.
echo Move DUKE-MAP.BAT to the same folder that you installed Duke3d in.
echo.
echo The location of DUKE-MAP.BAT is - %0
echo Unable to find DUKE3D.EXE in >> .\duke-map.log
echo.
cd >> .\duke-map.log
echo. >> .\duke-map.log
pause
:reset
set ZUF=
set CWD=
set CMDLINE=
goto help

:badinput
echo oops!
echo I couldn't find the folder %1 - perhaps you mis-spelt it?
echo You entered -
echo %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
echo.
echo Unable to find folder %1 in >> .\duke-map.log
cd >> .\duke-map.log
echo. >> .\duke-map.log
goto help

:help
if not "%ZUC%"=="Y" goto help1
echo.
echo Would you like to read the instructions?
choice.com /n/T:x,60/c:nops0extquz23456789yhi?`~1 (Y)es, (N)o, or e(X)it -
if errorlevel 255 goto end
if errorlevel 20 goto instructions
if errorlevel 6 goto exit
echo Press any key to quit
pause >nul
set ZUC=
exit
goto:0
:help1
echo Press any key for the instructions
pause >nul
:instructions
cls
echo Duke-Map helps you organize your maps so you don't have to deal with the
echo   difficult task of organizing maps, tiles, cons and other files.
echo.
echo How to use Duke-Map:
echo.
echo 1) Extract duke-map.bat to the folder that you installed Duke Nukem 3D in.
echo      The default install location for Duke3D is C:\DUKE3D
echo 2) Place each map in a sub-folder of Duke3D
echo      Use a folder name similar to the map name for your convenience
echo      Also place any other files, such as tiles and sounds in that folder
echo      Your map files will then be in a folder something like - C:\DUKE3D\MAPNAME
echo      For example if you have STADIUMZ.ZIP extract it to C:\DUKE3D\STADIUMZ
echo 3) Run the command - duke-map FOLDER
echo      Where FOLDER is the folder name that you placed your map files in
echo      For the above example you would type - duke-map stadiumz
echo.
echo Duke-Map will then copy all those files to the Duke3D folder and
echo   start Duke Nukem 3D using the user map and files in that folder
echo Duke-Map will also delete all those files when you quit the game
echo Duke-Map backs up any files that would be over-written,
echo   and restores them when you quit the game.
echo.
if not "%ZUC%"=="Y" goto instruc2
choice.com /n/c:xetn2o3b4i1 (T)ips, (O)ptions, (B)ugs, (N)ext, or e(X)it -
if errorlevel 8 goto bugs
if errorlevel 6 goto options
if errorlevel 3 goto tips
goto exit
:instruc2
pause
:tips
cls
echo -- Tips --
echo.
echo You can create a shortcut to Duke-Map and here's how:
echo 1) Do a right-click+drag on duke-map.bat to the place you want the shortcut in.
echo 2) From the menu select "Create Shortcut Here".
echo 3) You can rename the shortcut to anything else, like "Run Duke Map".
echo 4) Right-click on this shortcut and select "Properties" from the menu.
echo 5) Select the "Program" tab.
echo 6) Edit the "Cmd line:" box by adding a space and ? so it looks something like
echo      C:\DUKE3D\DUKE-MAP.BAT ?
echo 7) Make sure the "Working:" box is also the folder that Duke3D is in.
echo 8) Select the Memory tab.
echo 8) In the Initial Environment list select 1024
echo      - this program may not work with that set to "Auto".
echo 8) Click "OK".
echo Now when you run the shortcut you will get a prompt that you can
echo   enter the folder and options in, this is what adding the ? does.
echo - Note - press F1 when the curser is in the "Cmd line:" box for more info.
echo.
echo If you run Duke-Map from another batch file, be sure to CD to the Duke3d folder.
echo -- More Tips... Press any key --
pause >nul
cls
echo -- More Tips --
echo.
echo You can create more shortcuts with preset options, like run your favorite map.
echo   Copy the shortcut you made from the last tip.
echo   In place of the question mark type in your options - e.g. your map name.
echo   Rename the new shorcut, name it after your map.
echo You can use the normal command line options just like running Duke3d.exe
echo   You can use up to 5 additional parameters
echo   for example you could run
echo     duke-map stadiumz /q2 /s3
echo   to run Duke3D using the map files in the Stadiumz folder in fake multiplayer
echo     mode at skill level 3. For Atomic you could add the /a option as well (AI).
echo Any .cfg .con .wav .mid, etc. file in your map folder will be used in the game,
echo   that is, if you've named it correctly. Many maps come with extra files.
echo You can add custom configuration files to your map folder, Duke-Map will copy
echo   all files in your folder without ruining the defaults in the game folder.
echo If you copy duke3d.cfg to your map folder, then you make changes to options
echo   while in the game, they will be saved in your map folder. Others are not.
echo.
if not "%ZUC%"=="Y" goto tips2
choice.com /n/c:xeon3b4i1t2 (O)ptions, (B)ugs, (I)nstructions, (T)ips, (N)ext, or e(X)it -
if errorlevel 10 goto tips
if errorlevel 8 goto instructions
if errorlevel 6 goto bugs
if errorlevel 3 goto options
goto exit
:tips2
pause
:options
cls
echo -- Options --
echo.
echo   duke-map /h
echo This help screen.
echo.
echo   duke-map FOLDER [ options ]
echo FOLDER is the name of your map folder and [ options ] is up to 6 Duke3d options
echo   You can have multiple maps there as well, a list of three maps will show up.
echo.
echo   duke-map FOLDER run
echo The run option skips starting Duke3d.exe and quits. Use this option to copy
echo   your map files and run a different program, such as iCommit for multiplayer.
echo.
echo   duke-map FOLDER restore
echo The restore option restores your files after using the run option,
echo   or in case of a program crash or error.
echo Check the duke-map.log to see if you need to use the restore option. The log
echo   will show if files were restored. Whether it did or not depends on the error.
echo.
if not "%ZUC%"=="Y" goto options2
choice.com /n/c:xebn4i1t2o3 (B)ugs, (I)nstructions, (T)ips, (N)ext, or e(X)it -
if errorlevel 8 goto tips
if errorlevel 6 goto instructions
if errorlevel 3 goto bugs
goto exit
:options2
pause
:bugs
cls
echo -- Bugs --
echo.
echo Duke3d will start a normal game if there is no map in your folder - that's
echo   a feature, not a bug. It still copies files and passes on the options.
echo Log file -
echo This program creates a Duke-Map.log to help you track errors.
echo Multiple maps -
echo I tried to make a multi-map menu, but could only get 3 to work well. It may
echo   show the same one twice, but seems to work better if you use upper case.
echo   It only shows the maps in your map folder, and ignores any others.
echo Long file names and spaces -
echo Duke Nukem 3D is a MSDOS game, this program or Duke3d may not work as expected
echo   if you don't stick to the 8.3 filename format. Don't use a space in FOLDER.
echo DOS programs needed -
echo This program uses Find.exe and Choice.com, it will work without them, but not
echo   nearly as well. They are usually in C:\Windows\Command or the startup disk.
echo Large files -
echo This program copies EVERY file in your map folder. This may not be desirable if
echo   there are large zip or grp files there. It may run slow or run out of space.
pause
echo Read-Only files -
echo This program may produce an error if it tries to write over a read-only file.
echo   When you copy files off a CD in Windows, they will be read-only. Check that
echo   the main duke3d.cfg file is not read-only if you have one in your map folder.
echo   Have you made it read-only? Like to correct some bug in Duke Nukem?
echo - Note - To lock your options in any folder, set it's duke3d.cfg to read-only.
echo Environment space -
echo This program may use as much as 120 bytes of environment space. It does a test
echo   for that first, so if you need more it will tell you what to do.
echo The backup.tmp folder -
echo If backing up files a backup.tmp folder is created in your map folder, later
echo   it's deleted. Any subfolders will cause an error when it tries to delete it.
echo Other bugs -
echo - Duke version is checked but not currently used for anything.
echo - You may need to increase the DPMI memory in Properties.
echo - Not tested in WindowsXP or NT
echo - Windows
echo.
echo -- End of help --
if not "%ZUC%"=="Y" goto bugs2
choice.com /n/c:xei1t2o3b4 (I)nstructions, (T)ips, (O)ptions, (B)ugs, or e(X)it -
if errorlevel 9 goto bugs
if errorlevel 7 goto options
if errorlevel 5 goto tips
if errorlevel 3 goto instructions
goto exit
:bugs2
pause
echo.
goto exit

:envtest
:: Test environment space
echo Testing environment space...
echo.
:: We need less than 120 bytes?
set TESTSPACE=12345678901234567890123456789012345678901234567890
set TESTSPACF=12345678901234567890123456789012345678901234567890
if "%TESTSPACF%"=="" goto envtest1
set TESTSPACE=
set TESTSPACF=
goto envok
:envtest1
set TESTSPACE=
echo Testing environment space... 120 bytes >> .\duke-map.log
echo out of environment space >> .\duke-map.log
echo. >> .\duke-map.log
set >> .\duke-map.log
echo. >> .\duke-map.log
echo Increase your environment space permanently by using this line in CONFIG.SYS
echo SHELL=C:\WINDOWS\COMMAND.COM C:\WINDOWS\ /E:1024 /P
echo The default size in MSDOS is 256 so 1024 should be plenty
echo   OR
echo If you are running this in Windows you can change the environment settings by
echo   changing the settings for the batch file...
echo Right-Click on DUKE-MAP.BAT, select Properties, select the Memory tab
echo In the Initial Environment list select 1024 - that should be plenty
echo   - if this is running in a window you can click the Properties button above.
echo   - if it's not running in a window try pressing ALT+Enter then ALT+Space
echo   OR
echo I can try increasing the environment space to 1024
echo This is only a temporary change and should correct this problem for now,
echo   BUT, every time you run Duke-Map you will see this message
echo If you see this message after continuing then that means even 1024 isn't enough
echo.
echo PRESS CTRL+C or CTRL+Break to exit and change your settings
echo Or press space to continue, and I will increase the environment size
echo.
pause
echo increasing environment space...
echo Running new Command environment=1024 %0 >> .\duke-map.log
if "%COMSPEC%"=="" goto nocomspec
%COMSPEC% /E:1024 /C %0 %1 %2 %3 %4 %5 %6
echo Returning from %COMSPEC% %0 >> .\duke-map.log
echo Error on first run... >> .\duke-map.log
echo Tested environment space with 120 bytes >> .\duke-map.log
echo Ran out of environment space >> .\duke-map.log
echo Ran new Command environment=1024 >> .\duke-map.log
echo. >> .\duke-map.log
set >> .\duke-map.log
echo. >> .\duke-map.log
goto exit
:nocomspec
:: If no comspec, Command.com has to be on the root of the boot drive
if not exist C:\COMMAND.COM goto end
C:\COMMAND /E:1024 /C %0 %1 %2 %3 %4 %5 %6
echo Returning from command.com %0 >> .\duke-map.log
echo Errors on first run... >> .\duke-map.log
echo Tested environment space with 120 bytes >> .\duke-map.log
echo Ran out of environment space >> .\duke-map.log
echo Ran new Command environment=1024 >> .\duke-map.log
echo No COMSPEC, used C:\COMMAND.COM >> .\duke-map.log
echo. >> .\duke-map.log
set >> .\duke-map.log
echo. >> .\duke-map.log
goto exit

:noinput
echo oops!
echo You did not enter a folder name
echo Next time try typing -
echo   duke-map MapFolderName
echo.
echo -- Usage --
echo.
echo   duke-map FOLDER [ duke3d.exe options ]
echo   duke-map FOLDER [ run or restore ]
echo   duke-map /h for help.
echo.
echo Press any key to view FOLDER list.
pause >nul
cls
echo FOLDER list...
dir /ad/b/p
echo.
echo Press any key to exit
pause >nul
goto exit

:end
echo.
echo....Game Over... >> .\duke-map.log
echo "...Game Over..."
echo.
::pause
:exit
set ZUC=
cls
exit
:0